 using UnityEngine;
using System.Linq;
using System.Collections.Generic;

namespace Weapons
{
	public class Weapons
	{
		public static void Main()
		{  
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Fishing Rod",
                    NameToOrderByOverride = "Stick",
                    DescriptionOverride = "A fishing rod! It's designed for fishing, but I think you want to do something else.",
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Fishing Rod.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Fishing Rod.png");
                        var web = Instance.AddComponent<MaceBehaviour>();

                        Instance.AddComponent<PolygonCollider2D>();

                            PhysicalBehaviour phys = Instance.GetComponent<PhysicalBehaviour>();
                            phys.Properties = ModAPI.FindPhysicalProperties("Wood");
                            phys.InitialMass = 0.4f;
                            phys.TrueInitialMass = 0.4f;
                    }
                }
            );

		}
	}
	public class MaceBehaviour : MonoBehaviour
    {
        private GameObject gameobjectBall;

        public Vector2 ChainConnector = new Vector2(0f, 0.85f);
        public Vector2 ballConnector = new Vector2(0f, -0.05f);

        Sprite Ball;
        private void Awake()
        {
            var mace = ModAPI.CreatePhysicalObject("Float", ModAPI.LoadSprite("Sprites/Float.png"));
            foreach(var hitbox in mace.GetComponents<Collider2D>()) { Destroy(hitbox); }
            mace.AddComponent<CircleCollider2D>();           
            mace.transform.SetParent(gameObject.transform);
            mace.transform.localPosition = new Vector3(ChainConnector.x, ChainConnector.y + 1f);
            

            DistanceJoint2D joint = gameObject.AddComponent<DistanceJoint2D>();
            joint.maxDistanceOnly = true;
            joint.enableCollision = false;
            joint.distance = 1.5f;
            joint.autoConfigureDistance = false;
            joint.breakForce = Mathf.Infinity;
            joint.breakTorque = Mathf.Infinity;
            joint.anchor = ChainConnector;
            joint.connectedBody = mace.GetComponent<Rigidbody2D>();
            joint.connectedAnchor = ballConnector;
            JointCreated(joint);

            PhysicalBehaviour phys = mace.GetComponent<PhysicalBehaviour>();
            phys.Properties = ModAPI.FindPhysicalProperties("Wood");
            phys.InitialMass = 0.5f;
            phys.TrueInitialMass = 0.5f;
            
        }
        void JointCreated(DistanceJoint2D joint)
        {
            EnergyWireBehaviour energyWireBehaviour = joint.gameObject.AddComponent<EnergyWireBehaviour>();
            energyWireBehaviour.WireColor = Color.grey;
            energyWireBehaviour.WireMaterial = Resources.Load<Material>("Materials/Wire");
            energyWireBehaviour.WireWidth = 0.025f;
            energyWireBehaviour.typedJoint = joint;
        }
    } 
}   